/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

float *outdac;

float input_f[INPUT_MAX_DATA];

int process_input(int len)
{
    int i;
    int in_len;
    float max;

    in_len = typeNsamplesArray(datatype,len);

    type2float(input_data,input_f,in_len,datatype);

    /* scale to -1..1 */
    max=input_f[0];
    for (i=0;i<in_len;i++) {
        if (abs(input_f[i])>max)
            max=input_f[i];
    }

    if (max==0)
    	max=1;

    for (i=0;i<in_len;i++) {
        outdac[i]=input_f[i]*gain/max;
    }
    memcpy(outsignal,outdac,sizeof(float)*512);
    return 1;
}

/** Run function.
* @return 1 if ok, 0 if error
*/
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    outdac=hwapi_dac_getOutputBuffer();
    if (!outdac) {
        Log("Error getting dac output buffer\n");
        return 0;
    }
    return 1;
}


void ConfigInterfaces(){}


