/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

int barker13_seq[13]={1,1,1,1,1,-1,-1,1,1,-1,1,-1,1};
int output_i[13];

int addpreamble=1;

int process_input(int len)
{
    int long_out_block;
    int long_in_block;
    
    long_in_block=typeNsamplesArray(datatype,len);

    long_out_block = zeros_h+13;

    /* copy data */
    memcpy(&output_data[typeSizeArray(datatype,long_out_block)],input_data,typeSizeArray(datatype,long_in_block));
    long_out_block += long_in_block;

    /* set zeros at the end */
    memset(&output_data[typeSizeArray(datatype,long_out_block)],0,sizeof(int)*zeros_t);
    long_out_block += zeros_t;

    /* save to stats */
    type2int(output_data,output_int,128,datatype);

    /* send throught output */
    SendItf(0,typeSizeArray(datatype,long_out_block));

    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    int i;
    /* put 8 zeros */
    /*memset(output_i,0,sizeof(int)*8);
    int2type(output_i,output_data,8,datatype);
*/

    /* set zeros at the beggining*/
    for (i=0;i<zeros_h/2;i++)
        output_i[i]=0;
    for (i=zeros_h/2;i<zeros_h;i++)
        output_i[i]=0;

    int2type(output_i,output_data,zeros_h,datatype);

    /* now sync */
    for (i = 0; i < 13; i++) {
        output_i[i]=barker13_seq[i]*scale;
    }

     /* copy preamble */
    int2type(output_i,&output_data[typeSizeArray(datatype,zeros_h)],13,datatype);

    addpreamble=1;

    return 1;
}


void ConfigInterfaces(){}


