/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "itf_types.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "fdacoefs.h"

int mem[128];
int filter[128];

int process_input(int len)
{
    int i;
    int nsamples;
    
    nsamples=typeNsamplesArray(datatype,len);

    type2int(input_data,input_i,nsamples,datatype);

    for (i=0;i<nsamples;i++) {
        output_i[i]=abs(input_i[i]);
        output_i[i]=convii(filter,mem,avg_len,output_i[i])/att;
    }

    int2type(output_i,output_data,nsamples,datatype);
    
    /* send throught output */
    SendItf(0,len);

    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    int i;

    memset(mem,0,sizeof(int)*128);
    for (i=0;i<128;i++)
        filter[i]=1;
}


void ConfigInterfaces()
{
    
}



