////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  FILE:        cconv_imp.c                                                  //
//                                                                            //
//  FUNCTION:    Convolutional encoder                                        //
//                                                                            //
//  Description: Bit Level Control mode for Downlink WiMAX IEEE802.16e        //
//               rel 2005                                                     //
//               							      //
//                            						      //
//							                      //
//                                                                            //
//June 2009                                                                   //
////////////////////////////////////////////////////////////////////////////////


/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>



#include "itf_types.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "typetools.h"


char symbols[INPUT_MAX_DATA];

int numblocks,longblock;
int first=1;
int process_input(int length)
{
    int i,rpm,wpm;
    
    if (length == 0)
        return (-1);

    /* check length */
    if (length!=typeSizeArray(TYPE_BITSTREAM,numblocks*longblock)) {
        printf("CCONV: Invalid input length: len=%d ninput=%d*%d\n",length,numblocks,longblock);
        return 0;
    }

    rpm=0;
    wpm=0;
    for (i=0;i<numblocks;i++) {
        /** length is in bytes */
        encode(&symbols[wpm],&input_data[rpm],length,0,0,
                control_cconv.CCcoderate,control_cconv.K,control_cconv.poly);
        rpm+=typeSizeArray(TYPE_BITSTREAM,longblock);
        wpm+=typeSizeArray(TYPE_BITSTREAM,(longblock+control_cconv.K-1)*control_cconv.CCcoderate);
    }


    char2bin(symbols,output_data,(longblock+control_cconv.K-1)*control_cconv.CCcoderate);
    SendItf(0,typeSizeArray(TYPE_BITSTREAM,numblocks*(longblock+control_cconv.K-1)*control_cconv.CCcoderate));

    return (1);
}


int InitCustom() {

    return 1;
}

int RunCustom() {
    return 1;
}



int process_control(int len) {
    numblocks = control_cconv.num_blocks;
    longblock = control_cconv.long_block;
    printf("O---->CCONV: inputlength=%d bytes, numblocks=%d rate=%.2f\n",
            control_cconv.long_block/8, control_cconv.num_blocks,(float) 1/control_cconv.CCcoderate);
    return 1;
}


void ConfigInterfaces(){}






