
#ifndef _STATS_H
#define	_STATS_H

int stat_min,stat_max,stat_output,stat_input,stat_gain,stat_phase;

int fourier_samples,freqi_samples,transitory;
float sampling_freq,max_freq,min_freq;

int ts_delay;

#define MAX_FOURIER_SAMPLES 1024

float gain[MAX_FOURIER_SAMPLES];
float phase[MAX_FOURIER_SAMPLES];


struct utils_param params[] = {
    {"ts_delay",STAT_TYPE_INT,1,&ts_delay},
    {"fourier_samples",STAT_TYPE_INT,1,&fourier_samples},
    {"freqi_samples",STAT_TYPE_INT,1,&freqi_samples},
    {"transitory",STAT_TYPE_INT,1,&transitory},
    {"sampling_freq",STAT_TYPE_FLOAT,1,&sampling_freq},
    {"max_freq",STAT_TYPE_FLOAT,1,&max_freq},
    {"min_freq",STAT_TYPE_FLOAT,1,&min_freq},

    {NULL, 0, 0, 0}};


struct utils_stat stats[] = {    
                            {"out_signal",
                            STAT_TYPE_FLOAT,
                            512,
                            &stat_output,
                            (void*)&output_data,
                            WRITE},

                            {"in_signal",
                            STAT_TYPE_FLOAT,
                            512,
                            &stat_input,
                            (void*)&input_data,
                            WRITE},

                            {"channel_gain",
							STAT_TYPE_FLOAT,
							MAX_FOURIER_SAMPLES,
							&stat_gain,
							(void*)&gain,
							WRITE},

                            {"channel_phase",
							STAT_TYPE_FLOAT,
							MAX_FOURIER_SAMPLES,
							&stat_phase,
							(void*)&phase,
							WRITE},

							{"max_freq",
							STAT_TYPE_FLOAT,
							1,
							&stat_max,
							(void*)&max_freq,
							READ},

							{"min_freq",
							STAT_TYPE_FLOAT,
							1,
							&stat_min,
							(void*)&min_freq,
							READ},

                            {NULL, 0, 0, 0, 0, 0}};


#endif	/* _STATS_H */

