#ifndef _ITF_TYPES
#define	_ITF_TYPES

//CONTROL GENERIC
////////////////////////////////////////////////////////////////////////////////
///////////////////////DATA CONTROL/////////////////////////////////////////////
/*Define the module control parameters*/
#define MAXPSEQ     20  //MAXIMUM LENGTH OF PUNCTURING SEQUENCE
#define MAXVALUE    128

/*Values for "status"*/
#define NONACTIVE 	0
#define ACTIVE		1	/*Defines a module as active*/
#define TEST_FLOW	2	/*Test flows: Bypass data flow mode*/
#define TEST_PROCESS	3	/*Test Module Process*/

/*Values for punct_rate parameter:  Indicate the relation between bits input/bits output*/
				//CC CODING RATE=1/2
#define RATE1R1		1.0	//PUNCTURING RATE=1
#define RATE4R3		4.0/3.0	//PUNCTURING RATE=4/3
#define RATE3R2		3.0/2.0	//PUNCTURING RATE=3/2
#define RATE5R3		5.0/3.0	//PUNCTURING RATE=5/3

/*Control STRUCT                            */
typedef struct {		/*Defined according the control out needs*/
    int status;
    int time_slot;
    int inputdatalength;
    int outputdatalength;
    float punct_rate;           //Puncturing rate: (input bits)/(output bits)
    int numZEROS;
    int pseqlength;             //Puncturing sequence length
    int punctseq[MAXPSEQ];       //Define puncturing sequence:
                                //zero indicate punctured data
                                //one indicate non punctured data
}CDepunc_h;

/*Other option
struct generic_h		//Defined according the control out needs//
{
  
};		
*/

#endif
