#include <math.h>
#define PI 3.1415926535


void rcos(float *taps, int Ntaps, float alpha, int rate)
{
    double x1,x2,x3;
    double xindx;
    int i;

    for (i=0;i<Ntaps;i++) {
        xindx = (double) i-Ntaps/2;
        x1 = PI*xindx/rate;
        x2 = 1-(4*alpha*alpha*(xindx/rate)*(xindx/rate));
        if (x1==0) {
            taps[i]=1;
        } else if (x2 == 0) {
            x2 = 8*alpha*(xindx/rate)*(xindx/rate);
            taps[i]=sin(x1)*sin(alpha*x1)/x2;
        } else {
            taps[i]=(sin(x1)*cos(alpha*x1))/(x1*x2);
        }
    }
}

void rrcos(float *taps, int Ntaps, float alpha, int rate)
{
    double x1,x2,x3;
    double xindx;
    double nom,denom;
    int i;
    
    for (i=0;i<Ntaps;i++) {
        xindx = (double) i-Ntaps/2;
        x1 = PI*xindx/rate;
        x2 = 4*alpha*xindx/rate;
        x3 = x2*x2-1;
        if (x3!=0) {
                if (x1!=0) {
                    nom = cos((1+alpha)*x1) +  sin((1-alpha)*x1)/(4*alpha*xindx/rate);
                } else {
                    nom = cos((1+alpha)*x1) + (1-alpha)*PI/(4*alpha);
                }
                denom = x3*PI;
                taps[i]=-4*alpha*nom/denom;
        } else {
                if (alpha==1) {
                    taps[i]=1;
                } else {
                    x3 = (1-alpha)*x1;
                    x2 = (1+alpha)*x1;
                    nom  = sin(x2)*(1+alpha)*PI - cos(x3)*((1-alpha)*PI*rate)/(4*alpha*xindx)
                                    + sin(x3)*rate*rate/(4*alpha*xindx*xindx);
                    denom = 32*PI*alpha*alpha*xindx/rate;
                    taps[i]=4*alpha*nom/denom;
                }
        }
    }

}
