/** ALOE headers
 */
#include <phal_sw_api.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "inputs.h"
#include "outputs.h"
#include "stats.h"


int process_input(int len)
{
    int i;
    int nsamples;
    short *sh0,*sh1;
    int *in0,*in1;
    float *fl0,*fl1;
    char *ch0,*ch1;

    nsamples=typeSizeArray(datatype,len);

    switch(datatype) {
        case TYPE_CHAR:
            ch0=(char*) input_data0;
            ch1=(char*) input_data1;
            for (i=0;i<nsamples;i++)
                ch0[i]*=ch1[i];
            break;
        case TYPE_SHORT:
            sh0=(short*) input_data0;
            sh1=(short*) input_data1;
            for (i=0;i<nsamples;i++)
                sh0[i]*=sh1[i];
            break;
        case TYPE_INT:
            in0=(int*) input_data0;
            in1=(int*) input_data1;
            for (i=0;i<nsamples;i++)
                in0[i]*=in1[i];
            break;
        case TYPE_FLOAT:
            fl0=(float*) input_data0;
            fl1=(float*) input_data1;
            for (i=0;i<nsamples;i++)
                fl0[i]*=fl1[i];
            break;
    }
    return 1;
}


/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    return 1;
}


void ConfigInterfaces()
{
    
}



