/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

int input_i[INPUT_MAX_DATA];

int process_input(int len)
{
    int long_out_block;
    int long_in_block;
    int i,j;

    long_in_block=typeNsamplesArray(datatype,len);

    type2int(input_data,input_i,long_in_block,datatype);

    if (rate > long_in_block || rate<0) {
        Log("Error invalid interpolation rate: %d len %d\n", rate, long_in_block);
        return 0;
    }

    long_out_block = long_in_block*rate;

    if (long_out_block > OUTPUT_MAX_DATA) {
        Log("Output sequence bigger than buffer\n");
        return 0;
    }
    
    /* process data */
    for (i = 0; i < long_in_block; i++) {
        for (j=0;j<rate;j++) {
            output_i[i*rate+j] = input_i[i];
        }
    }

    int2type(output_i,output_data,long_out_block,datatype);

    /* send throught output */
    SendItf(0,typeSizeArray(datatype,long_out_block));

    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    return 1;
}


void ConfigInterfaces(){}


