/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

int input_i[INPUT_MAX_DATA];
int input_up[INPUT_MAX_DATA];

int downcnt=0;

int process_input(int len)
{
    int long_out_block;
    int long_in_block;
    int i,j;

    long_in_block=typeNsamplesArray(datatype,len);

    type2int(input_data,input_i,long_in_block,datatype);

    if (!downrate) downrate=1;
    if (!uprate) uprate=1;

    long_out_block = (long_in_block*uprate)/downrate;

    if (long_out_block > OUTPUT_MAX_DATA) {
        Log("Output sequence bigger than buffer\n");
        return 0;
    }
    
    /* upsampling */
    for (i = 0; i < long_in_block; i++) {
        input_up[i*uprate] = input_i[i];
        for (j=1;j<uprate;j++) {
            input_up[i*uprate+j]=0;
        }
    }

    /* downsampling */
    
    j=0;
    downcnt=0;
    for (i = 0; i < long_in_block*uprate; i++) {
        if (!downcnt) {
            output_i[j] = input_up[i];
            j++;
        }
        downcnt++;
        if (downcnt==downrate) downcnt=0;
    }

    int2type(output_i,output_data,long_out_block,datatype);

    /* send throught output */
    SendItf(0,typeSizeArray(datatype,long_out_block));

    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    return 1;
}


void ConfigInterfaces(){}


