/* 
 * Define here the inputs for the module
 */

#ifndef _INPUTS_H
#define	_INPUTS_H


/** Interface Name: input
 *  
 *  Data type: 32-bit signed integer
 *  Max input samples: 1024
 *  Min input samples: 1
 *  
 *  Callback function: process_input1
 *
 *  Description: Input stream of data
 */

#define INPUT_MAX_DATA	50*1024*1024	/*Max Number of data symbols*/

/** Type declaration */
typedef char input1_t;

/** buffer for data */
input1_t input_data[INPUT_MAX_DATA];


/* processing function */
int process_input(int len);


/** configure input interfaces */
struct utils_itf input_itfs[] = {
                    {"input",           
                    sizeof(input1_t),
                    INPUT_MAX_DATA,
                    input_data,         
                    NULL,      
                    process_input},     

                    {NULL, 0, 0, 0, 0, 0}};

/** =============== End ================  */





#endif	/* _INPUTS_H */

