/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#define PI 3.1415

#include "inputs.h"
#include "outputs.h"
#include "stats.h"


int get_output_length()
{
    /* use gettempo to get number of samples */
    return GetTempo(freq);
}

/** Run function.
* @return 1 if ok, 0 if error
*/
int generate_output(int len)
{
	int i;
	
	if (!len) 
            return 1;

        Log("Generating sampfreq %.1f sin freq %.1f len %d\n", freq,fsin,len);
        
	/* generate sinusoid */
	for (i=0;i<len;i++) {
            output_data[i] = (float) cosf((double) 2.0*PI*fsin*i/freq);
	}

        if (stat_signal)
            SetStatsValue(stat_signal, output_data, len);

	return 1;
}

int InitCustom()
{
    return 1;
}

int RunCustom()
{
    return 1;
}

void ConfigInterfaces(){}


