/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "modem.h"
#include "typetools.h"


int data_i[INPUT_MAX_DATA],data_q[INPUT_MAX_DATA];

int bitspersymbol;

int rcv_i,rcv_q;

int process_input_i(int len)
{
    rcv_i=len;
}

int process_input_q(int len)
{
    rcv_q=len;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{

    int len;
    int i,j;
    int s;
    int max;
    
    len=typeNsamplesArray(datatype,rcv_i);

    if (!len)
        return 1;

    bitspersymbol = getbitspersymbol(modulation);

    type2int(input_data_i,data_i,len,datatype);

    if (rcv_q)
        type2int(input_data_q,data_q,len,datatype);
    else
        memset(data_q,0,len*sizeof(int));

    j=0;
    for (i=0;i<len;i++) {
        if (modulation==MOD_ASK) {
            data_i[j]-=threshold;
        }
        Demodulate((modulation==MOD_ASK)?MOD_BPSK:modulation,data_i[j],data_q[j],&s);
        ConvertSymbolToBits(s,&outputbits[j],bitspersymbol);
        j+=bitspersymbol;
    }

    char2bin(outputbits,output_data,j);

    SendItf(0,typeSizeArray(TYPE_BITSTREAM,j));

    rcv_i=0;
    rcv_q=0;

    return 1;
}

int InitCustom()
{
    rcv_i=0;
    rcv_q=0;
    return 1;
}

void ConfigInterfaces(){}



