/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "modem.h"
#include "typetools.h"

char inputbits[INPUT_MAX_DATA*8];

int bitspersymbol;

int int_out_i[OUTPUT_MAX_DATA],int_out_q[OUTPUT_MAX_DATA];

int process_input(int len)
{
    int i,j;
    int s;
    int nbits;

    bitspersymbol = getbitspersymbol(modulation);

    nbits=typeNsamplesArray(TYPE_BITSTREAM,len);

    bin2char(input_data,inputbits,nbits);

    j=0;
    for (i=0;i<nbits;i+=bitspersymbol) {
        ConvertBitsToSymbol(&inputbits[i],&s,bitspersymbol);
        Modulate(modulation,s,&int_out_i[j],&int_out_q[j]);
        j++;
    }

    int2type(int_out_i,output_data_i,j,datatype);
    int2type(int_out_q,output_data_q,j,datatype);

    SendItf(0,typeSizeArray(datatype,j));
    SendItf(1,typeSizeArray(datatype,j));

    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    return 1;
}

void ConfigInterfaces(){}



