
int source_ready();
int source_send0(int len);
int source_send1(int len);
int crc_ready();
int crc_send0(int len);
int crc_send1(int len);
int coder_ready();
int coder_send0(int len);
int coder_send1(int len);
int ratem_ready();
int ratem_send0(int len);
int ratem_send1(int len);
int interl_ready();
int interl_send0(int len);
int interl_send1(int len);
int rfsegm_ready();
int rfsegm_send0(int len);
int rfsegm_send1(int len);
int trchmux_ready();
int trchmux_send(int len);
int phch_ready();
int phch_send(int len);
int dpcch_ready();
int dpcch_send(int len);

#define TX_ITFS  16
#define RX_ITFS  13

/** configure output interfaces */
struct utils_itf output_itfs_tx[TX_ITFS] = {
                {"binsource_0",
                 sizeof(struct binsource_h),
                 1,
                 &ctrlsource,
                 source_ready,
                 source_send0
                },
                {"crc_0",
                 sizeof(struct crc_h),
                 1,
                 &ctrlcrc,
                 crc_ready,
                 crc_send0
                },
                {"coder_0",
                 sizeof(struct codec_h),
                 1,
                 &ctrlcdc,
                 coder_ready,
                 coder_send0
                },
                {"ratem_0",
                 sizeof(struct ratem_h),
                 1,
                 &ctrlrm,
                 ratem_ready,
                 ratem_send0
                },
                {"interleaver_0",
                 sizeof(struct interleaver_h),
                 1,
                 &ctrlint,
                 interl_ready,
                 interl_send0
                },
                {"rfsegm_0",
                 sizeof(struct timemux_h),
                 1,
                 &ctrltimemux,
                 rfsegm_ready,
                 rfsegm_send0
                },

                {"binsource_1",
                 sizeof(struct binsource_h),
                 1,
                 &ctrlsource,
                 source_ready,
                 source_send1
                },
                {"crc_1",
                 sizeof(struct crc_h),
                 1,
                 &ctrlcrc,
                 crc_ready,
                 crc_send1
                },
                {"coder_1",
                 sizeof(struct cconv_h),
                 1,
                 &ctrlcconv,
                 coder_ready,
                 coder_send1
                },
                {"ratem_1",
                 sizeof(struct ratem_h),
                 1,
                 &ctrlrm,
                 ratem_ready,
                 ratem_send1
                },
                {"interleaver_1",
                 sizeof(struct interleaver_h),
                 1,
                 &ctrlint,
                 interl_ready,
                 interl_send1
                },
                {"rfsegm_1",
                 sizeof(struct timemux_h),
                 1,
                 &ctrltimemux,
                 rfsegm_ready,
                 rfsegm_send1
                },

                {"trchmux",
                 sizeof(struct chmux_h),
                 1,
                 &ctrlmux,
                 trchmux_ready,
                 trchmux_send
                },
                {"phch",
                 sizeof(struct interleaver_h),
                 1,
                 &ctrlint,
                 phch_ready,
                 phch_send
                },
                {"dpcchout",
                 sizeof(struct uectrl_h),
                 1,
                 &uectrl,
                 dpcch_ready,
                 dpcch_send
                },


                {NULL, 0, 0, 0, 0, 0}};



/** configure output interfaces */
struct utils_itf output_itfs_rx[RX_ITFS] = {
                {"uncrc_0",
                 sizeof(struct crc_h),
                 1,
                 &ctrlcrc,
                 crc_ready,
                 crc_send0
                },
                {"decoder_0",
                 sizeof(struct codec_h),
                 1,
                 &ctrlcdc,
                 coder_ready,
                 coder_send0
                },
                {"unratem_0",
                 sizeof(struct ratem_h),
                 1,
                 &ctrlrm,
                 ratem_ready,
                 ratem_send0
                },
                {"deinterleaver_0",
                 sizeof(struct interleaver_h),
                 1,
                 &ctrlint,
                 interl_ready,
                 interl_send0
                },
                {"unrfsegm_0",
                 sizeof(struct timemux_h),
                 1,
                 &ctrltimemux,
                 rfsegm_ready,
                 rfsegm_send0
                },

                {"uncrc_1",
                 sizeof(struct crc_h),
                 1,
                 &ctrlcrc,
                 crc_ready,
                 crc_send1
                },
                {"decoder_1",
                 sizeof(struct viterbi_h),
                 1,
                 &ctrlviterbi,
                 coder_ready,
                 coder_send1
                },
                {"unratem_1",
                 sizeof(struct ratem_h),
                 1,
                 &ctrlrm,
                 ratem_ready,
                 ratem_send1
                },
                {"deinterleaver_1",
                 sizeof(struct interleaver_h),
                 1,
                 &ctrlint,
                 interl_ready,
                 interl_send1
                },
                {"unrfsegm_1",
                 sizeof(struct timemux_h),
                 1,
                 &ctrltimemux,
                 rfsegm_ready,
                 rfsegm_send1
                },

                {"trchdemux",
                 sizeof(struct chmux_h),
                 1,
                 &ctrlmux,
                 trchmux_ready,
                 trchmux_send
                },
                {"unphch",
                 sizeof(struct interleaver_h),
                 1,
                 &ctrlint,
                 phch_ready,
                 phch_send
                },


                {NULL, 0, 0, 0, 0, 0}};


