/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "itf_types.h"
#include "ratem.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

int longtti,longttirm;
int configured;

char outputbits[8*INPUT_MAX_DATA];
char test[8*INPUT_MAX_DATA];

int process_input(int len)
{
    int i,n;

    if (!configured)
        return 1;

    if (len!=typeSizeArray(TYPE_BITSTREAM,longtti)) {
        Log("RateM: Invalid input length: longtti=%d len=%d\n",longtti,len);
    }

    bin2char(input_data,outputbits,longtti);

    /*if (ctrlpkt.uplink)
        Rate_Match_TrCH_uplink(outputbits,input_data,&ctrlpkt);
    else*/


    Rate_Match_TrCH_downlink(outputbits,input_data,&ctrlpkt);


    char2bin(input_data,output_data,longttirm);

    /* send throught output */
    SendItf(0,typeSizeArray(TYPE_BITSTREAM,longttirm));

    return 1;
}

int process_control(int len) {
    configured=1;
    longtti=ctrlpkt.long_tti;
    longttirm=ctrlpkt.long_tti_rm;
    Log("RateM: longtti=%d longttirm=%d\n",longtti,longttirm);
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    configured=0;
    longtti=0;
    longttirm=0;
    return 1;
}


void ConfigInterfaces(){}



