/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "itf_types.h"
#include "ratem.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

int longtti,longttirm;
int configured;

int process_input(int len)
{
    int i;
    if (!configured)
        return;

    if (len<longttirm) {
        Log("UnRateM: Invalid input length. longttirm=%d wpm=%d\n",longttirm,len);
        return 0;
    }

    /* ====== UnrateMatch ====== */
    Un_Rate_Match_TrCH(input_data,output_data,&ctrlpkt);

    /* send throught output */
    SendItf(0,longtti);

    return 1;
}

int process_control(int len) {
    configured=1;
    longtti=ctrlpkt.long_tti;
    longttirm=ctrlpkt.long_tti_rm;
    Log("UnRateM: longtti=%d longttirm=%d\n",longtti,longttirm);
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    configured=0;
    longtti=0;
    longttirm=0;
    return 1;
}


void ConfigInterfaces(){}



