
#ifndef _CCCONV_H
#define	_CCCONV_H

/*Values for modulation parameter. Indicate the number of bits per symbol*/
#define _BPSK 	1
#define _QPSK 	2
#define _16QAM 	4
#define _64QAM 	6
#define NO_MOD	7

/*Values for cconv parameter CC CODE RATE*/
#define CODERATE1R2	0.5		/*1/2*/
#define CODERATE3R4	0.75		/*3/4*/
#define CODERATE2R3	0.666666	/*2/3*/
#define CODERATE5R6	0.833333	/*5/6*/
/*Values for channelcoding*/
#define CC	0
#define	CTC	1
#define LDPC	2 

//CONTROL CCONV
////////////////////////////////////////////////////////////////////////////////
///////////////////////DATA CONTROL/////////////////////////////////////////////
/*Define the module control parameters*/
typedef struct		//Defined according the control out needs//
{
  int ninputbytes;	//Number of input data bytes//  
  int noutputbytes;	//Number of output data bytes//

  int channelcoding;	//	CC: Convolutional coding
  			//	CTC: Convolutional Turbo code
			//	LDPC: Low Density Parity Check
			  				
  float CCcoderate; 	//CCONC: 	Convolutional code rate//
  			//IN WIMAX ALWAYS 1/2----->CODERATE1R2	
			
  int tail;		//CCONV: 	Number of bytes of tail: 1 byte; 8 bits //
  
}CData_cconv;		//COntrol Data Convolutional Encoder//
////////////////////////////////////////////////////////////////////////////////
///////////////////////EXECUTION CONTROL////////////////////////////////////////
/*Define the execution control parameters*/
#define NONACTIVE 	0
#define ACTIVE		1	/*Defines a module as active*/
#define TEST_FLOW	2	/*Test flows: Bypass data flow mode*/
#define TEST_PROCESS	3	/*Test Module Process*/	
typedef struct		//Defined according the control out needs
{
  int status;		//Define the status
  int timeslot;		//Define the timeslot to produce the change
}CExec_cconv;
////////////////////////////////////////////////////////////////////////////////
///////////////////////CONTROL TYPE/////////////////////////////////////////////
typedef struct		//Defined according the control out needs
{
  CData_cconv CData;		
  CExec_cconv CExec;		 
}CCconv;		//Control Convolutional Encoder functionality


#endif
