#ifndef _CCHANNEL_H
#define	_CCHANNEL_H

/*Values ch:mode*/
#define NONOISE		0
#define GAUSSIAN 	1
#define SUI1 		10
#define SUI2 		11
#define SUI3 		12
#define SUI4		13


//CONTROL CHANNEL
////////////////////////////////////////////////////////////////////////////////
///////////////////////DATA CONTROL/////////////////////////////////////////////
/*Define the module control parameters*/
typedef struct		//Defined according the control out needs//
{
  int ninputdata;	//Number of input data bytes//  
  int noutputdata;	//Number of output data values//
  float EbNo;		//EbNo
  int channel_mode;	//WHITENOISE, SUI
  
}CData_channel;		//COntrol Channel//
////////////////////////////////////////////////////////////////////////////////
///////////////////////EXECUTION CONTROL////////////////////////////////////////
/*Define the execution control parameters*/
#define NONACTIVE 	0
#define ACTIVE		1	/*Defines a module as active*/
#define TEST_FLOW	2	/*Test flows: Bypass data flow mode*/
#define TEST_PROCESS	3	/*Test Module Process*/	
typedef struct		//Defined according the control out needs
{
  int status;		//Define the status
  int timeslot;		//Define the timeslot to produce the change
}CExec_channel;
////////////////////////////////////////////////////////////////////////////////
///////////////////////CONTROL TYPE/////////////////////////////////////////////
typedef struct		//Defined according the control out needs
{
  CData_channel CData;		
  CExec_channel CExec;		 
}CChannel;		//Control Channel functionality


#endif
