/*
 * Define here the outputs for the module
 */

#ifndef _INPUTS_H
#define	_INPUTS_H

/** Type declaration */
#include "CDataSource.h"	/*Defines the Control Struct for Data Source*/

#define INPUT_MAX_CONTROL 1	/*Max buffer size for control symbols*/


/* buffer for data flow*/
CDataSource input_control[INPUT_MAX_CONTROL];


/* defined interfaces functions*/
int get_controlin_length();
int process_inputcontrol();

/** configure input interfaces */
struct utils_itf input_itfs[] = {
               		{"control_flow_in",          		/**<< Name of the interface */
                 	sizeof(CDataSource), 		/**<< Size of the sample (in bytes) */
                 	INPUT_MAX_CONTROL,   		/**<< Pointer where to store data */
                 	input_control,       		/**<< Buffer for data */
                 	get_controlin_length, 		/**Returns number of samples to read from flow
                                              		Set to NULL to read all */
                 	process_inputcontrol,   	/**<< Function to process data */
                	},
                    	{NULL, 0, 0, 0, 0, 0}};

/** =============== End ================  */

#endif	/* _INPUTS_H */






