//////////////////////////////////////////////////////////////////////////////////////////
//											//
//	CC CODING RATE(CCCR)=1/2							//
//	WIMAX OVERALL CODING RATE (WOCR)						//
//	WIMAX PUNCTURING RATES (WPR)							//
//											//
//	WPR1R1=1									//
//	WPR4R3=4/3									//
//	WPR3R2=3/2									//
//	WPR5R3=5/3									//
//											//
//	WOCR1R2=WPR1R1*CCCR=1/2								//
//	WOCR2R3=WPR4R3*CCCR=2/3								//
//	WOCR3R4=WPR3R2*CCCR=3/4								//
//	WOCR5R6=WPR5R3*CCCR=5/6								//
//											//
//////////////////////////////////////////////////////////////////////////////////////////
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "puncturing_code.h"




//  punctmatrix:    puncturing matrix: 1 not punctured, 1 punctured
//  lengthpseq:     length of puncturing sequence
//  outlength:      returns the output length

int puncturing(int *punctmatrix, int lengthpseq,\
                    int msglength, int *in, int *out)
{
    int a=0;
    int outlength, l, i;

    	//PUNCTURING
	if(a==0){
            printf("punturing() lengthpseq=%d\n", lengthpseq);
            printf("PUNCTURING MATRIX:  ");
            for(i=0; i<lengthpseq; i++)printf("%d ", punctmatrix[i]);
   	    printf("\n");
        }

	l=0;
	for(i=0; i<msglength; i++){
		if(*(punctmatrix+i%lengthpseq)==1){
			*(out+l)=*(in+i);
			l++;
		}
	}
	a=0;
        outlength=l;
	return(outlength);

}


int depuncturing(int *punctmatrix, int lengthpseq,\
                    int inlength, int outlength, float *in, float *out)
{
    int l, i, numpunc=0;
    float numdataout;

        //CHECK THE NUMBER OF NON PUNCTURED DATA
        for(i=0; i<lengthpseq; i++)if(punctmatrix[i]==1)numpunc++;

	//DEPUNCTURING
	//printf("depuncturing length=%d\n", inlength);
	l=0;
	i=0;
	while(i<inlength){
		if(*(punctmatrix+l%lengthpseq)==1){
			*(out+l)=*(in+i);
			i++;
		}
		else *(out+l)=0;
		l++;
	}

        //CHECK IF ALL DATA OUT
         while(l < outlength)
        {
            *(out+l)=0;
            l++;
        }

	//printf("depunctured length=%d\n", l);
	return(l);
}






int opuncturing(float rate, int length, int *in, int *out)
{
					//PUNCTURING FORMATS: 0 indicate bit out
int rate1R1[2]={1,1};			//Punturing matrix for rate 1/2
int rate4R3[4]={1,1,0,1};		//Puncturing matrix for rate 2/3
int rate3R2[6]={1,1,0,1,1,0};		//Puncturing matrix for rate 3/4
int rate5R3[10]={1,1,0,1,1,0,0,1,1,0};	//Puncturing matrix for rate 5/6
int *rateformat;

int puncsize,  l, i, n;

static int inwordlength;
static int a=0;

	if(a==0)printf(" puncturing() rate=%f\n", rate);

	if(rate==RATE1R1){
		inwordlength=2;
		rateformat=rate1R1;
		if(a==0)printf("punturing() RATE1R1\n");
	}
	if(rate==RATE4R3){
		inwordlength=4;
		rateformat=rate4R3;
		if(a==0)printf("punturing() RATE4R3\n");
	}
	if(rate==RATE3R2){
		inwordlength=6;
		rateformat=rate3R2;
		if(a==0)printf("punturing() RATE3R2\n");
	}
	if(rate==RATE5R3){
		inwordlength=10;
		rateformat=rate5R3;
		if(a==0)printf("punturing() RATE5R3\n");
	}
	//PUNCTURING
	if(a==0)printf("punturing() rate=%f, inwordlength=%d\n", rate, inwordlength);

	l=0;
	for(i=0; i<length; i++){
		if(*(rateformat+i%inwordlength)==1){
			*(out+l)=*(in+i);
			l++;
		}
		else if(rate==RATE1R1)printf("ERROR: inwordlength=%d?\n", inwordlength);
	}
	a=0;
	return(l);
}

int odepuncturing(float rate, int length, float *in, float *out)
{

					//PUNCTURING FORMATS: 0 indicate bit out
int rate1R1[2]={1,1};			//Punturing matrix for rate 1/2
int rate4R3[4]={1,1,0,1};		//Puncturing matrix for rate 2/3
int rate3R2[6]={1,1,0,1,1,0};		//Puncturing matrix for rate 3/4
int rate5R3[10]={1,1,0,1,1,0,0,1,1,0};	//Puncturing matrix for rate 5/6
int *rateformat;

int puncsize, inwordlength, l, i;

	if(rate==RATE1R1){
		inwordlength=2;
		rateformat=rate1R1;
	}
	if(rate==RATE4R3){
		inwordlength=4;
		rateformat=rate4R3;
	}
	if(rate==RATE3R2){
		inwordlength=6;
		rateformat=rate3R2;
	}
	if(rate==RATE5R3){
		inwordlength=10;
		rateformat=rate5R3;
	}
	//DEPUNCTURING
	//printf("depuncturing length=%d\n", length);
	l=0;
	i=0;
	while(i<length){
		if(*(rateformat+l%inwordlength)==1){
			*(out+l)=*(in+i);
			i++;
		}
		else *(out+l)=0;
		l++;
	}
	//printf("depunctured length=%d\n", l);
	return(l);
}












